找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 794|回复: 0

[布局] 从外部DWG拷贝块定义到当前图形

[复制链接]

已领礼包: 40个

财富等级: 招财进宝

发表于 2021-1-7 19:44:35 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
问题:
I'm trying to copy a block definition from one drawing to the current drawing
using the wblock function
but the function is returning eFileInternalErr error. What am I doing wrong?


解答:
The wblock function is meant for writing out database contents. What you are
trying to do is the opposite, i.e. reading the contents of an external file
into the current database. You should be using the  insert function for this.

The code snippet below shows how to use one of the overloaded insert functions
to copy a block definition from an external file to the current database.



  1. void AdskCopyBlockDef()
  2. {
  3.    struct resbuf *rb;
  4.    char *fname;
  5.    AcDbObjectId blockId;
  6.     rb = acutNewRb(RTSTR);
  7. Acad::ErrorStatus es;


  8.     acedGetFileD("Pick drawing containing block def", NULL, "dwg", 0, rb);
  9. if(acutNewString(rb->resval.rstring,fname) != Acad::eOk ){
  10.   acutPrintf("\nString memory allocation failed");
  11.         acutRelRb(rb);
  12.   return;
  13. }
  14.     acutRelRb(rb);


  15.     AcDbDatabase *pSourceDb = new AcDbDatabase(Adesk::kFalse);
  16.      pSourceDb->readDwgFile(fname);



  17.      char SourceBlockdefName[132];
  18.   acedGetString(0,"Enter block def. name in source DWG: ",SourceBlockdefName);


  19.    char DestBlockdefName[132];
  20.   acedGetString(0,"Enter destination block def. name: ",DestBlockdefName);



  21.      //Get current database
  22.   AcDbDatabase *pCurDb = acdbHostApplicationServices()->workingDatabase();



  23.   //Insert the chosen block definition
  24.     es = pCurDb -> insert(blockId,SourceBlockdefName,DestBlockdefName,pSourceDb) ;
  25. if (es != Acad::eOk){
  26.   acutPrintf("\nBlock Def copy  failed. Error: %d",es);
  27.   return;
  28. }

  29.   acutDelString(fname);
  30. }




Note: This insert() function seems to create two block definiitions: the source
and the named copy, with the original being as in the external drawing, but
the copy being empty. This behaviour, which has also been observed in AutoCAD
2004, has been logged as a change request for further investigation.

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-4-29 11:15 , Processed in 0.306318 second(s), 25 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表